<template>
  <el-menu
    :default-active="activeIndex"
    class="el-menu-demo"
    mode="horizontal"
    background-color=""
    text-color="#000"
    active-text-color="#4392f7"
    @select="handleSelect"
  >
    <el-icon
      :size="20"
      v-show="!menuclose"
      class="fold"
      @click="SpreadMenu(true)"
      ><Fold
    /></el-icon>
    <el-icon
      :size="20"
      v-show="menuclose"
      class="fold"
      @click="SpreadMenu(false)"
      ><Expand
    /></el-icon>
    <div class="logo">
      <img src="@/assets/nanchang.png" style="width: 30px; height: 30px" />
      <span>校车预约管理系统</span>
    </div>
    <div class="login">
      <span class="dateTime">{{ dateTime }}</span>
      <el-badge :value="titlenumber" class="item" v-if="titlenumber">
        <img
          src="@/assets/news.png"
          @click="newsClick"
          style="width: 20px; height: 20px; cursor: pointer"
          alt=""
        />
        <!-- <el-icon><Bell /></el-icon> -->
      </el-badge>
      <img
        v-else
        src="@/assets/news.png"
        @click="newsClick"
        style="width: 20px; height: 20px; cursor: pointer"
        alt=""
      />
      <div class="flex flex-wrap items-center" style="cursor: pointer">
        <el-dropdown :hide-on-click="false" trigger="click">
          <el-avatar :size="30">
            <img
              src="https://cube.elemecdn.com/0/88/03b0d39583f48206768a7534e55bcpng.png"
            />
          </el-avatar>
          <template #dropdown>
            <el-dropdown-menu>
              <el-dropdown-item @click="uppassword">
                <el-icon class="switchButton" :size="20" color="#000">
                  <Lock />
                </el-icon>
                <span>修改密码</span>
              </el-dropdown-item>
              <el-dialog
                :append-to-body="true"
                custom-class="pw"
                v-model="uppasswordShow"
                title="修改密码"
                width="30%"
                :before-close="uppasswordClose"
                align-center
                :close-on-click-modal="false"
              >
                <el-form
                  ref="ruleFormRef"
                  :model="ruleForm"
                  :rules="rules"
                  label-width="100px"
                  class="demo-ruleForm"
                  :size="formSize"
                  label-position="left"
                  status-icon
                >
                  <el-form-item label="原密码" prop="oldpass">
                    <el-input
                      v-model="ruleForm.oldpass"
                      placeholder="请输入原密码"
                      clearable
                    />
                  </el-form-item>
                  <el-form-item label="新密码" prop="nowpass">
                    <el-input
                      v-model="ruleForm.nowpass"
                      placeholder="请输入新密码"
                      clearable
                    />
                  </el-form-item>
                  <el-form-item
                    label="确定新密码"
                    prop="correctpass"
                    style="
                      padding-bottom: 40px;
                      border-bottom: 1px solid rgba(230, 230, 230, 1);
                    "
                  >
                    <el-input
                      v-model="ruleForm.correctpass"
                      placeholder="请再次输入新密码"
                      clearable
                    />
                  </el-form-item>

                  <el-form-item class="options">
                    <el-button
                      class="queding"
                      type="primary"
                      @click="submitForm(ruleFormRef)"
                    >
                      确定
                    </el-button>
                    <el-button class="congzhi" @click="resetForm(ruleFormRef)"
                      >重置</el-button
                    >
                  </el-form-item>
                </el-form>
                <!-- <template #footer>
                  <span class="dialog-footer">
                    <el-button @click="dialogVisible = false">取消</el-button>
                    <el-button type="primary" @click="dialogVisible = false">
                      确定
                    </el-button>
                  </span>
                </template> -->
              </el-dialog>
              <el-dropdown-item @click="loginOut">
                <el-icon class="switchButton" :size="20" color="#000">
                  <SwitchButton />
                </el-icon>
                <span>退出登录</span>
              </el-dropdown-item>
            </el-dropdown-menu>
          </template>
        </el-dropdown>
      </div>
      <span class="name">{{ username }}</span>
    </div>
  </el-menu>
</template>

<script setup>
import { ref, reactive, onBeforeMount, onMounted, watch } from "vue";
import { ElMessage, ElMessageBox, ElNotification } from "element-plus";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import { dayjs } from "element-plus";
import axios from "axios";

const store = useStore();
const router = useRouter();
const username = ref(); // 账号名称
const titlenumber = ref(1); //  消息条数
const activeIndex = ref(); // 路由路径
const loginOutDialogVisible = ref(false); // 退出按钮
const menuclose = ref(false); // 左边状态栏展开按钮状态
const uppasswordShow = ref(false); // 修改密码展示框
const ruleForm = reactive({
  oldpass: "",
  nowpass: "",
  correctpass: "",
});
const ruleFormRef = ref();
// 表单验证
const rules = reactive({
  oldpass: [
    {
      required: true,
      message: "密码不能为空",
      trigger: "blur",
    },
  ],
  nowpass: [
    {
      required: true,
      message: "新密码不能为空",
      trigger: "blur",
    },
  ],
  correctpass: [
    {
      required: true,
      message: "两次密码是否输入正确",
      trigger: "blur",
    },
  ],
  // desc: [{ required: true, message: "Please input activity form", trigger: "blur" }],
});

// 监控消息通知数量
watch(
  () => store.state.user.newsNum,
  (newValue, oldValue) => {
    titlenumber.value = newValue;
    console.log(newValue, "监控消息数量");
  }
);

// 点击消息通知
const newsClick = () => {
  store.commit("indexUp", 0);
  sessionStorage.setItem("sidevarItem", 0);
  router.push({
    path: `/schoolBus/news`,
  });
};
const dateTime = ref(
  dayjs().format("YYYY-MM-DD") + ` 星期四 ` + dayjs().format("HH:mm:ss")
); // 时间

// 选择菜单
const handleSelect = (key, keyPath) => {
  store.commit("navbarUpdata", key);
  activeIndex.value = key;
};

// 展开按钮
const SpreadMenu = (flag) => {
  store.commit("menuClose", flag);
  menuclose.value = flag;
};
// 修改密码
const uppassword = () => {
  uppasswordShow.value = true;
  // ruleForm.oldpass = store.state.user.password;
};
const uppasswordClose = () => {
  uppasswordShow.value = false;
  // ruleForm.oldpass = "";
  // ruleForm.nowpass = "";
  // ruleForm.correctpass = "";
  ruleFormRef.value.resetFields();
};
// 提交修改密码表单
const submitForm = async (formEl) => {
  if (!formEl) return;
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      let data = new FormData();
      data.set("page", 1);
      data.set("rows", 2000); //前面的key记得对应！
      let res = await axios({
        method: "post",
        url: "/api/carBook/adminlist.action",
        headers: {
          token: sessionStorage.getItem("token"),
        },
        data,
      });
      // console.log(res.data.rows);
      let account = res.data.rows.filter((item) => {
        return item.number == sessionStorage.getItem("username");
      });
      console.log(account);
      let dataUpdata = {
        name: account[0].name,
        number: account[0].number,
        password: ruleForm.correctpass,
        id: account[0].id,
      };
      if (ruleForm.oldpass == account[0].password) {
        if (ruleForm.nowpass == ruleForm.correctpass) {
          let resUpdata = await axios({
            method: "post",
            url: "/api/carBook/adminupdate.action",
            headers: {
              "Content-Type": "application/json;charset=utf-8",
              token: sessionStorage.getItem("token"),
            },
            data: dataUpdata,
          });
          console.log(resUpdata);
          if (resUpdata.data.code == 200) {
            ElMessage({
              type: "success",
              showClose: true,
              message: resUpdata.data.message,
              center: true,
            });
            sessionStorage.removeItem("token");
            localStorage.removeItem("pass");
            uppasswordShow.value = false;
            ruleFormRef.value.resetFields();
            ElNotification({
              type: "warning",
              title: "提示!!!",
              message: "密码已修改,请重新登录页面",
              // duration: 0,
              // position: "top-right",
            });
          } else {
            ElMessage({
              type: "error",
              showClose: true,
              message: res.data.message,
              center: true,
            });
          }
        } else {
          ElMessage({
            type: "error",
            showClose: true,
            message: "两次密码输入不正确",
            center: true,
          });
        }
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: "原密码输入错误",
          center: true,
        });
      }
    } else {
      console.log("error submit!", fields);
    }
  });
};
// 重置表单
const resetForm = (formEl) => {
  // console.log("重置表单");
  if (!formEl) return;
  formEl.resetFields();
};

const loginOut = () => {
  ElMessageBox.confirm("是否退出登录?", "提示", {
    confirmButtonText: "确认",
    cancelButtonText: "取消",
    type: "warning",
  })
    .then(() => {
      sessionStorage.removeItem("token");
      router.push({
        path: `/login`,
      });
      ElMessage({
        type: "success",
        message: "退出成功",
      });
    })
    .catch(() => {
      ElMessage({
        type: "info",
        message: "已取消登录",
      });
    });
};

onMounted(() => {
  activeIndex.value = store.state.user.navbar;
  if (sessionStorage.getItem("newsNum") == 0) {
    titlenumber.value = "";
  } else {
    titlenumber.value = sessionStorage.getItem("newsNum");
  }

  username.value = sessionStorage.getItem("username");
  // handleSelect("vidicons");
  setInterval(() => {
    var week = ["日", "一", "二", "三", "四", "五", "六"];
    var datas = dayjs().day();
    dateTime.value =
      dayjs().format("YYYY-MM-DD") +
      ` 星期${week[datas]} ` +
      dayjs().format("HH:mm:ss");
  }, 1000);
});
</script>

<style scoped lang="scss">
.el-menu--horizontal {
  border-bottom: none;
  display: flex;
  align-items: center;
  height: 65px;
  // width: 100%;
  background-color: #fff;
  box-shadow: 5px 5px 10px 0px rgba(213, 228, 252, 1);
  .logo {
    left: 90px;
    display: flex;
    align-items: center;
    span {
      margin-left: 10px;
      font-size: 24px;
      font-weight: 600;
    }
  }
  .login {
    color: #000;
    display: flex;
    align-items: center;
    position: absolute;
    right: 10px;
    top: 17px;

    .dateTime {
      margin-right: 20px;
    }
    .el-badge {
      display: flex;
      align-items: center;
      // :deep(.el-badge__content) {
      //   width: 2px;
      //   height: 14px;
      // }
    }
    .items-center {
      margin-left: 20px;
    }
    .name {
      height: 20px;
      line-height: 20px;
      text-decoration: underline;
      padding: 0 10px;
      margin: 0 10px;
      border-left: 2px solid #ccc;
    }
    .switchButton {
      cursor: pointer;
    }
  }
  .login:focus {
    outline: none;
  }
  .fold {
    width: 46px;
    height: 65px;
  }
  .fold:hover {
    cursor: pointer;
    background-color: rgba(67, 146, 249, 0.1);
  }
}
.el-dialog__body {
  .options {
    display: flex;
    flex-direction: row-reverse;
    :deep(.el-form-item__content) {
      margin-left: 0 !important;
      flex: none;
    }
  }
}
</style>
<style lang="scss">
.el-overlay {
  .el-overlay-dialog {
    .pw {
      border-radius: 11px;

      .el-dialog__header {
        border-radius: 11px 11px 0 0;
        background: rgba(237, 241, 245, 1);
        font-weight: 600;
        margin: 0;
        .el-dialog__headerbtn {
          outline: none;
        }
      }
      .el-dialog__body {
        padding: 30px 20px 10px 20px;
        .el-input {
          width: 200px;
        }
        .options {
          margin-left: 170px;
        }
      }
    }
  }
}
</style>
